/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 14.05.2009
Author  : 
Company : 
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd.h>

#define TWINT 7
#define TWEA 6
#define TWSTA 5
#define TWSTO 4
#define TWWC 3
#define TWEN 2
#define TWIE 0

#define Start TWCR=((1<<TWINT)|(1<<TWSTA)|(1<<TWEN))
#define Stop TWCR=((1<<TWINT)|(1<<TWEN)|(1<<TWSTO)) 
#define Send TWCR=((1<<TWINT)|(1<<TWEN))
#define Recieve TWCR=((1<<TWINT)|(1<<TWEA)|(1<<TWEN))
#define Execute (!(TWCR &(1<<TWINT)))

unsigned char* str;
unsigned char w,t;
char intOk;
char i =0; 

// 2 Wire bus interrupt service routine
interrupt [TWI] void twi_isr(void)
{
if (TWSR == 0xA8){TWDR=t; TWCR=0xC5; while (TWSR == 0xC0){};} //       
TWCR=0xC5; //    7(TWINT),6(TWEA),2(TWEN)  0(TWIE)-  
  
while (TWSR == 0x80){w=TWDR; intOk = 1;} //  TWDR           TWDR 

}

//void TWI_Send(unsigned char a)
//{
//    Start;
//    while(Execute);
//          
//    TWDR=0x01;// -  
//    Send;
//    while(Execute);
//          
//    TWDR=a;
//    Send;
//    while(Execute);
//          
//    Stop;
//    delay_us(20);
//}

void main(void)
{
    /* Reset WDT*/
    #asm("wdr")
//    /* Write logical one to WDTOE and WDE */
    WDTCR |= (1 << 4) | (1 << 3);
//    /* Turn off WDT */
    WDTCR = 0x00;

// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// 2 Wire Bus initialization
// Generate Acknowledge Pulse: Off
// 2 Wire Bus Slave Address: 26h
// General Call Recognition: Off
// Bit Rate: 100,000 kHz
TWSR=0x00;
TWBR=0x0C;
TWAR=0x4C;
//TWCR=0x05; // TWI   
TWCR=0x45;//    " " 0(TWIE), 2(TWEN)  7(TWEA) 
//  TWCR=0x04; // TWI   

// LCD module initialization
lcd_init(20);
// Global enable interrupts
#asm("sei")

lcd_gotoxy(1, 1);
lcd_putsf("Loading system ...");
//lcd_putsf("OS time:");
//lcd_gotoxy(0, 1);
//lcd_putsf("OS date:");

//lcd_gotoxy(9, 0);

      
while (1)
      {
           if (intOk==1) {
          
            switch (w)
            {
                case 0xFF: //goto 0,0          
                    lcd_gotoxy(0, 0);
                    break;
                
                case 0xF3: //goto 0,1  
                    lcd_gotoxy(0, 1);
                    break;
                    
                case 0xF5: //goto Eth0 address         
                    lcd_gotoxy(0, 2);
                    break;
                    
                case 0xF7: //goto Eth1 address         
                    lcd_gotoxy(0, 3);
                    break;
                    
                case 0xF9: //Read keyboard         
//                    TWI_Send(121);
                    TWDR=0x79;
                    Send;
                    lcd_putsf("Keyboard request");
                    break;
                    
                default: 
//              lcd_puts((unsigned char*)w);
                  lcd_putchar(w);
                  intOk = 0;
                  break;
            }
                           
          }
     
      };
}
